sumNeighbor3 <- function (sp, data, lag = -1, bor = 1) 
{
    ddd <- dim(data)
    if (length(ddd) < 3) 
        return(sapply(sumNeighbor2(sp, data), function(x) 
	  as.numeric(.extract.border(x, bor = bor))))
    else {
        spterms <- attr(terms(sp), "term.labels")
	print(spterms)
	lag <- cbind(lag, 1:length(spterms))[,1]
        res <- sapply(sumNeighbor2(sp, data[, , 1]), function(x) 
           as.numeric(.extract.border(x, bor = bor)))
        for (i in 2:ddd[3]) 
           res <- rbind(res, sapply(sumNeighbor2(sp, data[, , i]), function(x) 
	        as.numeric(.extract.border(x, bor = bor))))
	if(!all(lag==0)) {
	   res0 <- res
	   ids <- lapply(1:ddd[3], function(i) (i-1)*prod(ddd[1:2]-2*bor)+1:prod(ddd[1:2]-2*bor))
	   tmin <- -min(lag)+1
	   res <- matrix(res0[unlist(ids[tmin:ddd[3]+lag[1]]), 1], ncol=1)
	   if (ncol(res0)>1)
	     for (i in 2:ncol(res0))
               res <- cbind(res, res0[unlist(ids[tmin:ddd[3]+lag[i]]), i])
	   colnames(res) <- colnames(res0)
	}
        return(res)
    }
}
