rLag <- function(sp, data, lag=-1, bor=1) {
  ddd <- dim(data)
  if (length(ddd)<3)
    return(sapply(sumNeighbor2(sp, data), function(x)
                  as.numeric(.extract.border(x, bor=bor))))
  else {
    res <- sapply(sumNeighbor2(sp, data[,,1]), function(x)
                  as.numeric(.extract.border(x, bor=bor)))
    if (ddd[3]>(1-lag))
      for (i in 2:(ddd[3]+lag))
        res <- rbind(res, sapply(sumNeighbor2(sp, data[,,i]),
                                 function(x)
                                 as.numeric(.extract.border(x, bor=bor))))
    return(res)
  }
}

