sumNeighbor2 <- function(sp, data) {
  data[is.na(data)] <- 0
  dd <- dim(data)
  cterm <- strsplit(as.character(sp)[2], " ")[[1]]
  res <- list()
  if (any(cterm=="S"))
    res$S <- data
  if (any(cterm=="R"))
    res$R <- cbind(0, data[, -dd[2]]) + cbind(data[, -1], 0)
  if (any(cterm=="C"))
    res$C <- rbind(0, data[-dd[1], ]) + rbind(data[-1, ], 0)
  if (any(cterm=="first")) 
    res$first <- cbind(0, data[, -dd[2]]) + cbind(data[, -1], 0) +
      rbind(0, data[-dd[1], ]) + rbind(data[-1, ], 0)
  if (any(cterm=="dA"))
    res$dA <- rbind(0, cbind(0, data[-dd[1], -dd[2]])) +
      rbind(cbind(data[-1, -1], 0), 0)
  if (any(cterm=="dB"))
    res$dB <- rbind(0, cbind(data[-dd[1], -1], 0)) +
      rbind(cbind(0, data[-1, -dd[2]]), 0)
  if (any(cterm=="D"))
    res$D <- rbind(0, cbind(0, data[-dd[1], -dd[2]])) +
      rbind(cbind(data[-1, -1], 0), 0) +
        rbind(0, cbind(data[-dd[1], -1], 0)) +
          rbind(cbind(0, data[-1, -dd[2]]), 0)
  if (any(cterm=="second"))
    res$second <- cbind(0, data[, -dd[2]]) + cbind(data[, -1], 0) +
      rbind(0, data[-dd[1], ]) + rbind(data[-1, ], 0) +
        rbind(0, cbind(0, data[-dd[1], -dd[2]])) +
          rbind(cbind(data[-1, -1], 0), 0) +
            rbind(0, cbind(data[-dd[1], -1], 0)) +
              rbind(cbind(0, data[-1, -dd[2]]), 0)
  for (i in 1:length(res)) 
    dimnames(res[[i]]) <- dimnames(data)
  return(res)
}

